#!/bin/sh

### environment
export LANG=C

# library directory
HDF5=/home/user1/util/hdf5_1.8.4-patch1
SZIP=/home/user1/util/szip_2.1

# compiler
fc=ifort
cc=icc

# source filename
fsrc="readL2L_hdf5.f"
csrc="amsr2time_.c"
obj=`echo $csrc|sed "s/\.c/.o/g"`

# output filename
out=readL2L_hdf5_f

# library order
lib="-lhdf5hl_fortran -lhdf5_hl -lhdf5_fortran -lhdf5 -lsz -lz -lm"

# c compile
cmd="$cc -g -c $csrc"
echo $cmd
$cmd

# f compile
cmd="$fc -g $fsrc $obj -o $out -I$HDF5/include -I$SZIP/include -L$HDF5/lib -L$SZIP/lib $lib"
echo $cmd
$cmd

# garbage
rm -f *.o
