      program main
      implicit none
C include
      include 'AMTK_f.h'
C intrinsic function
      integer(4) iargc ! pgf need explicitly declaration
C fixed value
      integer(4),parameter::LMT=2200 ! limit of NumberOfScans
C interface variable
      integer(4) i,j         ! loop variable
      integer(4) ret         ! return status
      character(len=512) buf ! text buffer
      character(len=512) fn  ! filename
      integer(4) hnd         ! file handle
C meta data
      character(len=512) geo  ! GeophysicalName
      character(len=512) gid  ! GranuleID
      character(len=512) tm1  ! ObservationStartDateTime
      character(len=512) tm2  ! EquatorCrossingDateTime
      character(len=512) tm3  ! ObservationEndDateTime
      integer(4) num          ! NumberOfScans
      integer(4) ovr          ! OverlapScans
      character(len=512) prm1 ! CoRegistrationParameterA1
      character(len=512) prm2 ! CoRegistrationParameterA2
C array data
      type(AM2_COMMON_SCANTIME) st(LMT) ! scantime
      type(AM2_COMMON_LATLON) ll89ar(AM2_DEF_SNUM_HI,LMT) ! latlon for 89a altitude revised
      type(AM2_COMMON_LATLON) ll89br(AM2_DEF_SNUM_HI,LMT) ! latlon for 89b altitude revised
      type(AM2_COMMON_LATLON) lllr(AM2_DEF_SNUM_LO,LMT)   ! latlon for low resolution
      real(4) tb06h06(AM2_DEF_SNUM_LO,LMT) ! tb for 06h, resolution 06G
      real(4) tb06v06(AM2_DEF_SNUM_LO,LMT) ! tb for 06v, resolution 06G
      real(4) tb07h06(AM2_DEF_SNUM_LO,LMT) ! tb for 07h, resolution 06G
      real(4) tb07v06(AM2_DEF_SNUM_LO,LMT) ! tb for 07v, resolution 06G
      real(4) tb10h10(AM2_DEF_SNUM_LO,LMT) ! tb for 10h, resolution 10G
      real(4) tb10v10(AM2_DEF_SNUM_LO,LMT) ! tb for 10v, resolution 10G
      real(4) tb18h23(AM2_DEF_SNUM_LO,LMT) ! tb for 18h, resolution 23G
      real(4) tb18v23(AM2_DEF_SNUM_LO,LMT) ! tb for 18v, resolution 23G
      real(4) tb23h23(AM2_DEF_SNUM_LO,LMT) ! tb for 23h, resolution 23G
      real(4) tb23v23(AM2_DEF_SNUM_LO,LMT) ! tb for 23v, resolution 23G
      real(4) tb36h36(AM2_DEF_SNUM_LO,LMT) ! tb for 36h, resolution 36G
      real(4) tb36v36(AM2_DEF_SNUM_LO,LMT) ! tb for 36v, resolution 36G
      real(4) tb89h36(AM2_DEF_SNUM_LO,LMT) ! tb for 89h, resolution 36G
      real(4) tb89v36(AM2_DEF_SNUM_LO,LMT) ! tb for 89v, resolution 36G
      real(4) tb89ah(AM2_DEF_SNUM_HI,LMT) ! tb for 89ah
      real(4) tb89av(AM2_DEF_SNUM_HI,LMT) ! tb for 89av
      real(4) tb89bh(AM2_DEF_SNUM_HI,LMT) ! tb for 89bh
      real(4) tb89bv(AM2_DEF_SNUM_HI,LMT) ! tb for 89bv
      integer(4) pdqlo(AM2_DEF_SNUM_LO*16,LMT) ! pixel data quality for low
      integer(1) pdq06h(AM2_DEF_SNUM_LO,LMT)   ! pixel data quality for 06h
      integer(1) pdq06v(AM2_DEF_SNUM_LO,LMT)   ! pixel data quality for 06v
      integer(1) pdq07h(AM2_DEF_SNUM_LO,LMT)   ! pixel data quality for 07h
      integer(1) pdq07v(AM2_DEF_SNUM_LO,LMT)   ! pixel data quality for 07v
      integer(4) pdqhi(AM2_DEF_SNUM_HI* 8,LMT) ! pixel data quality for high
      integer(1) pdq89ah(AM2_DEF_SNUM_HI,LMT)  ! pixel data quality for 89ah
      integer(1) pdq89av(AM2_DEF_SNUM_HI,LMT)  ! pixel data quality for 89av
      integer(1) pdq89bh(AM2_DEF_SNUM_HI,LMT)  ! pixel data quality for 89bh
      integer(1) pdq89bv(AM2_DEF_SNUM_HI,LMT)  ! pixel data quality for 89bv
      integer(4) loflo(AM2_DEF_SNUM_LO,LMT*4) ! land ocean flag for low
      integer(1) lof06(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 06 
      integer(1) lof10(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 10 
      integer(1) lof23(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 23 
      integer(1) lof36(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 36 
      integer(4) lofhi(AM2_DEF_SNUM_HI,LMT*2) ! land ocean flag for high
      integer(1) lof89a(AM2_DEF_SNUM_HI,LMT)  ! land ocean flag for 89a
      integer(1) lof89b(AM2_DEF_SNUM_HI,LMT)  ! land ocean flag for 89b
      real(4) ear_in(AM2_DEF_SNUM_LO,LMT) ! earth incidence
      real(4) ear_az(AM2_DEF_SNUM_LO,LMT) ! earth azimuth
C argument check
      if(iargc().lt.1)then
        write(*,'(a)')'argument: AMSR2 L1B DATA FILE (HDF5)'
        call exit(1)
      endif
C set filename
      call getarg(1,fn)
      write(*,'(a,a)')'input file: ',fn(1:len_trim(fn))
C open
      hnd=AMTK_openH5(fn)
      if(hnd.lt.0)then
        write(*,'(a,a)')'AMTK_openH5 error: ',fn(1:len_trim(fn))
        write(*,'(a,i12)')'amtk status: ',hnd
        call exit(1)
      endif
C read meta: GeophysicalName
      ret=AMTK_getMetaDataName(hnd,'GeophysicalName',geo)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getMetaDataName error: GeophysicalName'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,a)')'GeophysicalName: ',geo(1:len_trim(geo))
C read meta: GranuleID
      ret=AMTK_getMetaDataName(hnd,'GranuleID',gid)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getMetaDataName error: GranuleID'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,a)')'GranuleID: ',gid(1:len_trim(gid))
C read meta: ObservationStartDateTime
      ret=AMTK_getMetaDataName(hnd,'ObservationStartDateTime',tm1)
      if(ret.lt.0)then
        write(*,'(a,a)')'AMTK_getMetaDataName error: '
     +  ,'ObservationStartDateTime'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,a)')'ObservationStartDateTime: ',tm1(1:len_trim(tm1))
C read meta: EquatorCrossingDateTime
      ret=AMTK_getMetaDataName(hnd,'EquatorCrossingDateTime',tm2)
      if(ret.lt.0)then
        write(*,'(a,a)')'AMTK_getMetaDataName error: '
     +  ,'EquatorCrossingDateTime'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,a)')'EquatorCrossingDateTime: ',tm2(1:len_trim(tm2))
C read meta: ObservationEndDateTime
      ret=AMTK_getMetaDataName(hnd,'ObservationEndDateTime',tm3)
      if(ret.lt.0)then
        write(*,'(a,a)')'AMTK_getMetaDataName error: '
     +  ,'ObservationEndDateTime'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,a)')'ObservationEndDateTime: ',tm3(1:len_trim(tm3))
C read meta: NumberOfScans
      ret=AMTK_getMetaDataName(hnd,'NumberOfScans',buf)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getMetaDataName error: NumberOfScans'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      read(buf(1:ret),*)num
      write(*,'(a,i12)')'NumberOfScans: ',num
C check limit
      if(num.gt.LMT)then
        write(*,'(a,i6)')'limit error: limit of NumberOfScans = ',LMT
        call exit(1)
      else
        write(*,'(a,i6)')'limit of NumberOfScans = ',LMT
      endif
C read meta: OverlapScans
      ret=AMTK_getMetaDataName(hnd,'OverlapScans',buf)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getMetaDataName error: OverlapScans'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      read(buf(1:ret),*)ovr
      write(*,'(a,i12)')'OverlapScans: ',ovr
C read meta: CoRegistrationParameterA1
      ret=AMTK_getMetaDataName(hnd,'CoRegistrationParameterA1',prm1)
      if(ret.lt.0)then
        write(*,'(a,a)')'AMTK_getMetaDataName error: '
     +  ,'CoRegistrationParameterA1'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,a)')'CoRegistrationParameterA1: '
     +,prm1(1:len_trim(prm1))
C read meta: CoRegistrationParameterA2
      ret=AMTK_getMetaDataName(hnd,'CoRegistrationParameterA2',prm2)
      if(ret.lt.0)then
        write(*,'(a,a)')'AMTK_getMetaDataName error: '
     +  ,'CoRegistrationParameterA2'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,a)')'CoRegistrationParameterA2: '
     +,prm2(1:len_trim(prm2))
C read array: scantime
      ret=AMTK_getScanTime(hnd,1,num,st)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getScanTime error.'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,i4.4,"/",i2.2,"/",i2.2," ",i2.2,":",i2.2,":",i2.2)')
     +'time(scan=1): '
     +,st(1)%year
     +,st(1)%month
     +,st(1)%day
     +,st(1)%hour
     +,st(1)%minute
     +,st(1)%second
C read array: latlon for 89a altitude revised
      ret=AMTK_getLatLon(hnd,ll89ar,1,num,AM2_LATLON_RS_89A)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getLatLon error: AM2_LATLON_RS_89A'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,"(",f9.4,",",f9.4,")")')'latlon89ar(pixel=1,scan=1): '
     +,ll89ar(1,1)%lat,ll89ar(1,1)%lon
C read array: latlon for 89b altitude revised
      ret=AMTK_getLatLon(hnd,ll89br,1,num,AM2_LATLON_RS_89B)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getLatLon error: AM2_LATLON_RS_89B'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,"(",f9.4,",",f9.4,")")')'latlon89br(pixel=1,scan=1): '
     +,ll89br(1,1)%lat,ll89br(1,1)%lon
C read array: latlon for low resolution
      ret=AMTK_getLatLon(hnd,lllr,1,num,AM2_LATLON_RS_LO)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_getLatLon error: AM2_LATLON_RS_LO'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,"(",f9.4,",",f9.4,")")')'latlonlr(pixel=1,scan=1): '
     +,lllr(1,1)%lat,lllr(1,1)%lon
C read array: tb for 06h, resolution 06G
      ret=AMTK_get_SwathFloat(hnd,tb06h06,1,num,AM2_RES06_TB06H)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES06_TB06H'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb06h06(pixel=1,scan=1): ',tb06h06(1,1)
C read array: tb for 06v, resolution 06G
      ret=AMTK_get_SwathFloat(hnd,tb06v06,1,num,AM2_RES06_TB06V)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES06_TB06V'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb06v06(pixel=1,scan=1): ',tb06v06(1,1)
C read array: tb for 07h, resolution 06G
      ret=AMTK_get_SwathFloat(hnd,tb07h06,1,num,AM2_RES06_TB07H)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES06_TB07H'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb07h06(pixel=1,scan=1): ',tb07h06(1,1)
C read array: tb for 07v, resolution 06G
      ret=AMTK_get_SwathFloat(hnd,tb07v06,1,num,AM2_RES06_TB07V)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES06_TB07V'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb07v06(pixel=1,scan=1): ',tb07v06(1,1)
C read array: tb for 10h, resolution 10G
      ret=AMTK_get_SwathFloat(hnd,tb10h10,1,num,AM2_RES10_TB10H)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES10_TB10H'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb10h10(pixel=1,scan=1): ',tb10h10(1,1)
C read array: tb for 10v, resolution 10G
      ret=AMTK_get_SwathFloat(hnd,tb10v10,1,num,AM2_RES10_TB10V)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES10_TB10V'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb10v10(pixel=1,scan=1): ',tb10v10(1,1)
C read array: tb for 18h, resolution 23G
      ret=AMTK_get_SwathFloat(hnd,tb18h23,1,num,AM2_RES23_TB18H)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES23_TB18H'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb18h23(pixel=1,scan=1): ',tb18h23(1,1)
C read array: tb for 18v, resolution 23G
      ret=AMTK_get_SwathFloat(hnd,tb18v23,1,num,AM2_RES23_TB18V)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES23_TB18V'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb18v23(pixel=1,scan=1): ',tb18v23(1,1)
C read array: tb for 23h, resolution 23G
      ret=AMTK_get_SwathFloat(hnd,tb23h23,1,num,AM2_RES23_TB23H)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES23_TB23H'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb23h23(pixel=1,scan=1): ',tb23h23(1,1)
C read array: tb for 23v, resolution 23G
      ret=AMTK_get_SwathFloat(hnd,tb23v23,1,num,AM2_RES23_TB23V)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES23_TB23V'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb23v23(pixel=1,scan=1): ',tb23v23(1,1)
C read array: tb for 36h, resolution 36G
      ret=AMTK_get_SwathFloat(hnd,tb36h36,1,num,AM2_RES36_TB36H)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES36_TB36H'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb36h36(pixel=1,scan=1): ',tb36h36(1,1)
C read array: tb for 36v, resolution 36G
      ret=AMTK_get_SwathFloat(hnd,tb36v36,1,num,AM2_RES36_TB36V)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES36_TB36V'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb36v36(pixel=1,scan=1): ',tb36v36(1,1)
C read array: tb for 89h, resolution 36G
      ret=AMTK_get_SwathFloat(hnd,tb89h36,1,num,AM2_RES36_TB89H)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES36_TB89H'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb89h36(pixel=1,scan=1): ',tb89h36(1,1)
C read array: tb for 89v, resolution 36G
      ret=AMTK_get_SwathFloat(hnd,tb89v36,1,num,AM2_RES36_TB89V)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_RES36_TB89V'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb89v36(pixel=1,scan=1): ',tb89v36(1,1)
C read array: tb for 89ah
      ret=AMTK_get_SwathFloat(hnd,tb89ah,1,num,AM2_TB89AH)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_TB89AH'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb89ah(pixel=1,scan=1): ',tb89ah(1,1)
C read array: tb for 89av
      ret=AMTK_get_SwathFloat(hnd,tb89av,1,num,AM2_TB89AV)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_TB89AV'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb89av(pixel=1,scan=1): ',tb89av(1,1)
C read array: tb for 89bh
      ret=AMTK_get_SwathFloat(hnd,tb89bh,1,num,AM2_TB89BH)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_TB89BH'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb89bh(pixel=1,scan=1): ',tb89bh(1,1)
C read array: tb for 89bv
      ret=AMTK_get_SwathFloat(hnd,tb89bv,1,num,AM2_TB89BV)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_TB89BV'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'tb89bv(pixel=1,scan=1): ',tb89bv(1,1)
C read array: pixel data quality for low
      ret=AMTK_get_SwathInt(hnd,pdqlo,1,num,AM2_PIX_QUAL_LO)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathInt error: AM2_PIX_QUAL_LO'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          pdq06v(i,j)=pdqlo((i-1)*16+ 2,j)*10+pdqlo((i-1)*16+ 1,j)
          pdq06h(i,j)=pdqlo((i-1)*16+ 4,j)*10+pdqlo((i-1)*16+ 3,j)
          pdq07v(i,j)=pdqlo((i-1)*16+ 6,j)*10+pdqlo((i-1)*16+ 5,j)
          pdq07h(i,j)=pdqlo((i-1)*16+ 8,j)*10+pdqlo((i-1)*16+ 7,j)
        enddo
      enddo
      write(*,'(a,i3)')'pdq06h(pixel=1,scan=1): ',pdq06h(1,1)
      write(*,'(a,i3)')'pdq06v(pixel=1,scan=1): ',pdq06v(1,1)
      write(*,'(a,i3)')'pdq07h(pixel=1,scan=1): ',pdq07h(1,1)
      write(*,'(a,i3)')'pdq07v(pixel=1,scan=1): ',pdq07v(1,1)
C read array: pixel data quality for high
      ret=AMTK_get_SwathInt(hnd,pdqhi,1,num,AM2_PIX_QUAL_HI)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathInt error: AM2_PIX_QUAL_HI'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          pdq89ah(i,j)=pdqhi((i-1)*8+1,j)
          pdq89av(i,j)=pdqhi((i-1)*8+2,j)
          pdq89bh(i,j)=pdqhi((i-1)*8+3,j)
          pdq89bv(i,j)=pdqhi((i-1)*8+4,j)
        enddo
      enddo
      write(*,'(a,i3)')'pdq89ah(pixel=1,scan=1): ',pdq89ah(1,1)
      write(*,'(a,i3)')'pdq89av(pixel=1,scan=1): ',pdq89av(1,1)
      write(*,'(a,i3)')'pdq89bh(pixel=1,scan=1): ',pdq89bh(1,1)
      write(*,'(a,i3)')'pdq89bv(pixel=1,scan=1): ',pdq89bv(1,1)
C read array: land ocean flag for low
      ret=AMTK_get_SwathInt(hnd,loflo,1,num,AM2_LOF_RES_LO)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathInt error: AM2_LOF_RES_LO'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          lof06(i,j)=loflo(i,num*0+j)
          lof10(i,j)=loflo(i,num*1+j)
          lof23(i,j)=loflo(i,num*2+j)
          lof36(i,j)=loflo(i,num*3+j)
        enddo
      enddo
      write(*,'(a,i3)')'lof06(pixel=1,scan=1): ',lof06(1,1)
      write(*,'(a,i3)')'lof10(pixel=1,scan=1): ',lof10(1,1)
      write(*,'(a,i3)')'lof23(pixel=1,scan=1): ',lof23(1,1)
      write(*,'(a,i3)')'lof36(pixel=1,scan=1): ',lof36(1,1)
C read array: land ocean flag for high
      ret=AMTK_get_SwathInt(hnd,lofhi,1,num,AM2_LOF_RES_HI)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathInt error: AM2_LOF_RES_HI'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          lof89a(i,j)=lofhi(i,num*0+j)
          lof89b(i,j)=lofhi(i,num*1+j)
        enddo
      enddo
      write(*,'(a,i3)')'lof89a(pixel=1,scan=1): ',lof89a(1,1)
      write(*,'(a,i3)')'lof89b(pixel=1,scan=1): ',lof89b(1,1)
C read array: earth incidence
      ret=AMTK_get_SwathFloat(hnd,ear_in,1,num,AM2_EARTH_INC)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_EARTH_INC'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'ear_in(pixel=1,scan=1): ',ear_in(1,1)
C read array: earth azimuth
      ret=AMTK_get_SwathFloat(hnd,ear_az,1,num,AM2_EARTH_AZ)
      if(ret.lt.0)then
        write(*,'(a)')'AMTK_get_SwathFloat error: AM2_EARTH_AZ'
        write(*,'(a,i12)')'amtk status: ',ret
        call exit(1)
      endif
      write(*,'(a,f9.2)')'ear_az(pixel=1,scan=1): ',ear_az(1,1)
C close
      ret=AMTK_closeH5(hnd)
      end
