      program main
      use hdf5
      implicit none
C include
      include 'amsr2time_f.h'
C intrinsic function
      integer(4) iargc ! pgf need explicitly declaration
C fixed value
      integer(4),parameter::LMT=2200 ! limit of NumberOfScans
      integer(4),parameter::AM2_DEF_SNUM_HI=486 ! high resolution pixel width
      integer(4),parameter::AM2_DEF_SNUM_LO=243 ! low  resolution pixel width
C interface variable
      integer(4) i,j          ! loop variable
      integer(4) ret          ! return status
      character(len=512) buf  ! text buffer
      character(len=512) fn   ! filename
      integer(HID_T) fhnd     ! file handle
      integer(HID_T) ahnd     ! attribute handle
      integer(HID_T) atyp     ! attribute type
      integer(HID_T) dhnd     ! dataset handle
      integer(HID_T) dtyp     ! dataset type
      integer(HID_T) shnd     ! dataspace handle
      integer(HSIZE_T) sz1(3) ! array size 1
      integer(HSIZE_T) sz2(3) ! array size 2
C meta data
C HDF5 FORTRAN LIBRARY CAN'T RETRIEVE VARIABLE STRING !
C calculate NumberOfScans from array size and OverlapScans
C use fixed value for OverlapScans
C use fixed value for CoRegistrationParameter
C     character(len=512) geo  ! GeophysicalName
C     character(len=512) gid  ! GranuleID
C     character(len=512) tm1  ! ObservationStartDateTime
C     character(len=512) tm2  ! EquatorCrossingDateTime
C     character(len=512) tm3  ! ObservationEndDateTime
      integer(4) num          ! NumberOfScans
      integer(4) ovr          ! OverlapScans
C     real(8) prm1(7)         ! CoRegistrationParameterA1 -> 6G,7G,10G,18G,23G,36G,MEAN
C     real(8) prm2(7)         ! CoRegistrationParameterA2 -> 6G,7G,10G,18G,23G,36G,MEAN
      parameter(ovr=20)
C array buffer
      real(4) sca ! scale
      real(8) r8d1(LMT) ! array buffer for real(8) D1
      integer(4) i4d2hi(AM2_DEF_SNUM_HI,LMT) ! array buffer for integer(4) D2 high
C array data
      type(AM2_COMMON_SCANTIME) st(LMT) ! scantime
      real(4) lat89ar(AM2_DEF_SNUM_HI,LMT) ! lat for 89a altitude revised
      real(4) lat89br(AM2_DEF_SNUM_HI,LMT) ! lat for 89b altitude revised
      real(4) latlr(AM2_DEF_SNUM_LO,LMT)   ! lat for low resolution
      real(4) lon89ar(AM2_DEF_SNUM_HI,LMT) ! lon for 89a altitude revised
      real(4) lon89br(AM2_DEF_SNUM_HI,LMT) ! lon for 89b altitude revised
      real(4) lonlr(AM2_DEF_SNUM_LO,LMT)   ! lon for low resolution
      real(4) tb06h06(AM2_DEF_SNUM_LO,LMT) ! tb for 06h, resolution 06G
      real(4) tb06v06(AM2_DEF_SNUM_LO,LMT) ! tb for 06v, resolution 06G
      real(4) tb07h06(AM2_DEF_SNUM_LO,LMT) ! tb for 07h, resolution 06G
      real(4) tb07v06(AM2_DEF_SNUM_LO,LMT) ! tb for 07v, resolution 06G
      real(4) tb10h10(AM2_DEF_SNUM_LO,LMT) ! tb for 10h, resolution 10G
      real(4) tb10v10(AM2_DEF_SNUM_LO,LMT) ! tb for 10v, resolution 10G
      real(4) tb18h23(AM2_DEF_SNUM_LO,LMT) ! tb for 18h, resolution 23G
      real(4) tb18v23(AM2_DEF_SNUM_LO,LMT) ! tb for 18v, resolution 23G
      real(4) tb23h23(AM2_DEF_SNUM_LO,LMT) ! tb for 23h, resolution 23G
      real(4) tb23v23(AM2_DEF_SNUM_LO,LMT) ! tb for 23v, resolution 23G
      real(4) tb36h36(AM2_DEF_SNUM_LO,LMT) ! tb for 36h, resolution 36G
      real(4) tb36v36(AM2_DEF_SNUM_LO,LMT) ! tb for 36v, resolution 36G
      real(4) tb89h36(AM2_DEF_SNUM_LO,LMT) ! tb for 89h, resolution 36G
      real(4) tb89v36(AM2_DEF_SNUM_LO,LMT) ! tb for 89v, resolution 36G
      real(4) tb89ah(AM2_DEF_SNUM_HI,LMT) ! tb for 89ah
      real(4) tb89av(AM2_DEF_SNUM_HI,LMT) ! tb for 89av
      real(4) tb89bh(AM2_DEF_SNUM_HI,LMT) ! tb for 89bh
      real(4) tb89bv(AM2_DEF_SNUM_HI,LMT) ! tb for 89bv
      integer(1) pdq06h(AM2_DEF_SNUM_LO,LMT)  ! pixel data quality for 06h
      integer(1) pdq06v(AM2_DEF_SNUM_LO,LMT)  ! pixel data quality for 06v
      integer(1) pdq07h(AM2_DEF_SNUM_LO,LMT)  ! pixel data quality for 07h
      integer(1) pdq07v(AM2_DEF_SNUM_LO,LMT)  ! pixel data quality for 07v
      integer(1) pdq89ah(AM2_DEF_SNUM_HI,LMT) ! pixel data quality for 89ah
      integer(1) pdq89av(AM2_DEF_SNUM_HI,LMT) ! pixel data quality for 89av
      integer(1) pdq89bh(AM2_DEF_SNUM_HI,LMT) ! pixel data quality for 89bh
      integer(1) pdq89bv(AM2_DEF_SNUM_HI,LMT) ! pixel data quality for 89bv
      integer(4) loflo(AM2_DEF_SNUM_LO,LMT*4) ! land ocean flag for low
      integer(1) lof06(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 06 
      integer(1) lof10(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 10 
      integer(1) lof23(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 23 
      integer(1) lof36(AM2_DEF_SNUM_LO,LMT)   ! land ocean flag for 36 
      integer(4) lofhi(AM2_DEF_SNUM_HI,LMT*2) ! land ocean flag for high
      integer(1) lof89a(AM2_DEF_SNUM_HI,LMT)  ! land ocean flag for 89a
      integer(1) lof89b(AM2_DEF_SNUM_HI,LMT)  ! land ocean flag for 89b
      real(4) ear_in(AM2_DEF_SNUM_LO,LMT) ! earth incidence
      real(4) ear_az(AM2_DEF_SNUM_LO,LMT) ! earth azimuth
C argument check
      if(iargc().lt.1)then
        write(*,'(a)')'argument: AMSR2 L1B DATA FILE (HDF5)'
        call exit(1)
      endif
C set filename
      call getarg(1,fn)
      write(*,'(a,a)')'input file: ',fn(1:len_trim(fn))
C hdf5 initialize
      call H5open_f(ret)
      if(ret.lt.0)then
        write(*,'(a,i12)')'h5open_f error: ',ret
        call exit(1)
      endif
C open
      call H5Fopen_f(fn,H5F_ACC_RDONLY_F,fhnd,ret,H5P_DEFAULT_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Fopen error: ',fn(1:len_trim(fn))
        call exit(1)
      endif
C HDF5 FORTRAN LIBRARY CAN'T RETRIEVE VARIABLE STRING !
C calculate NumberOfScans from array size and OverlapScans
      call H5Dopen_f(fhnd,'Scan Time',dhnd,ret)
      call H5Dget_space_f(dhnd,shnd,ret)
      call H5Sget_simple_extent_dims_f(shnd,sz1,sz2,ret)
      if(ret.lt.0)then
        write(*,'(a)')'H5Sget_simple_extent_dims error: Scan Time'
        call exit(1)
      endif
      call H5Sclose_f(shnd,ret)
      call H5Dclose_f(dhnd,ret)
      num=sz1(1)-ovr*2
      write(*,'(a,i12)')'NumberOfScans(RETRIEVE BY ARRAY SIZE): ',num
      write(*,'(a,i12)')'OverlapScans(FIXED VALUE): ',ovr
C check limit
      if(num.gt.LMT)then
        write(*,'(a,i6)')'limit error: limit of NumberOfScans = ',LMT
        call exit(1)
      else
        write(*,'(a,i6)')'limit of NumberOfScans = ',LMT
      endif
C HDF5 FORTRAN LIBRARY CAN'T RETRIEVE VARIABLE STRING !
C use fixed value for CoRegistrationParameter
C     prm1(1)= 1.25000D0
C     prm1(2)= 1.00000D0
C     prm1(3)= 1.25000D0
C     prm1(4)= 1.25000D0
C     prm1(5)= 1.25000D0
C     prm1(6)= 1.00000D0
C     prm1(7)=(prm1(1)+prm1(2)+prm1(3)+prm1(4)+prm1(5)+prm1(6))/6.0D0
C     write(*,'(a,a,f8.5,a,f8.5,a,f8.5,a,f8.5,a,f8.5,a,f8.5)')
C    +'CoRegistrationParameterA1(FIXED VALUE): '
C    +,'6G-',prm1(1),',7G-',prm1(2),',10G-',prm1(3)
C    +,',18G-',prm1(4),',23G-',prm1(5),',36G-',prm1(6)
C     prm2(1)= 0.00000D0
C     prm2(2)=-0.10000D0
C     prm2(3)=-0.25000D0
C     prm2(4)= 0.00000D0
C     prm2(5)=-0.25000D0
C     prm2(6)= 0.00000D0
C     prm2(7)=(prm2(1)+prm2(2)+prm2(3)+prm2(4)+prm2(5)+prm2(6))/6.0D0
C     write(*,'(a,a,f8.5,a,f8.5,a,f8.5,a,f8.5,a,f8.5,a,f8.5)')
C    +'CoRegistrationParameterA2(FIXED VALUE): '
C    +,'6G-',prm2(1),',7G-',prm2(2),',10G-',prm2(3)
C    +,',18G-',prm2(4),',23G-',prm2(5),',36G-',prm2(6)
C read array: scantime
      ! read
      call H5Dopen_f(fhnd,'Scan Time',dhnd,ret)
      sz1(1)=LMT
      call H5Dread_f(dhnd
     +,H5T_NATIVE_DOUBLE,r8d1,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: ','Scan Time'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap
      do j=1,num
        r8d1(j)=r8d1(j+ovr)
      enddo
      do j=num+1,LMT
        r8d1(j)=0
      enddo
      ! convert
      call amsr2time(num,r8d1,st)
      ! sample display
      write(*,'(a,i4.4,"/",i2.2,"/",i2.2," ",i2.2,":",i2.2,":",i2.2)')
     +'time(scan=1): '
     +,st(1)%year
     +,st(1)%month
     +,st(1)%day
     +,st(1)%hour
     +,st(1)%minute
     +,st(1)%second
C read array: latlon for 89a altitude revised
      ! read lat
      call H5Dopen_f(fhnd
     +,'Latitude of Observation Point for 89A',dhnd,ret)
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,lat89ar,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Latitude of Observation Point for 89A'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! read lon
      call H5Dopen_f(fhnd
     +,'Longitude of Observation Point for 89A',dhnd,ret)
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,lon89ar,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Longitude of Observation Point for 89A'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap
      do j=1,num
        lat89ar(:,j)=lat89ar(:,j+ovr)
        lon89ar(:,j)=lon89ar(:,j+ovr)
      enddo
      do j=num+1,LMT
        lat89ar(:,j)=0
        lon89ar(:,j)=0
      enddo
      ! sample display
      write(*,'(a,"(",f9.4,",",f9.4,")")')'latlon89ar(pixel=1,scan=1): '
     +,lat89ar(1,1),lon89ar(1,1)
C read array: latlon for 89b altitude revised
      ! read lat
      call H5Dopen_f(fhnd
     +,'Latitude of Observation Point for 89B',dhnd,ret)
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,lat89br,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Latitude of Observation Point for 89B'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! read lon
      call H5Dopen_f(fhnd
     +,'Longitude of Observation Point for 89B',dhnd,ret)
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,lon89br,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Longitude of Observation Point for 89B'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap
      do j=1,num
        lat89br(:,j)=lat89br(:,j+ovr)
        lon89br(:,j)=lon89br(:,j+ovr)
      enddo
      do j=num+1,LMT
        lat89br(:,j)=0
        lon89br(:,j)=0
      enddo
      ! sample display
      write(*,'(a,"(",f9.4,",",f9.4,")")')'latlon89br(pixel=1,scan=1): '
     +,lat89br(1,1),lon89br(1,1)
C read array: latlon for low resolution
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          latlr(i,j)=lat89ar(i*2-1,j)
          lonlr(i,j)=lon89ar(i*2-1,j)
        enddo
      enddo
      write(*,'(a,"(",f9.4,",",f9.4,")")')'latlonlr(pixel=1,scan=1): '
     +,latlr(1,1),lonlr(1,1)
C read array: tb for 06h, resolution 06G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res06,6.9GHz,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb06h06,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res06,6.9GHz,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb06h06(i,j)=tb06h06(i,j+ovr)
          if(tb06h06(i,j).lt.65534)tb06h06(i,j)=tb06h06(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb06h06(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb06h06(pixel=1,scan=1): ',tb06h06(1,1)
C read array: tb for 06v, resolution 06G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res06,6.9GHz,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb06v06,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res06,6.9GHz,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb06v06(i,j)=tb06v06(i,j+ovr)
          if(tb06v06(i,j).lt.65534)tb06v06(i,j)=tb06v06(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb06v06(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb06v06(pixel=1,scan=1): ',tb06v06(1,1)
C read array: tb for 07h, resolution 06G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res06,7.3GHz,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb07h06,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res06,7.3GHz,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb07h06(i,j)=tb07h06(i,j+ovr)
          if(tb07h06(i,j).lt.65534)tb07h06(i,j)=tb07h06(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb07h06(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb07h06(pixel=1,scan=1): ',tb07h06(1,1)
C read array: tb for 07v, resolution 06G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res06,7.3GHz,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb07v06,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res06,7.3GHz,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb07v06(i,j)=tb07v06(i,j+ovr)
          if(tb07v06(i,j).lt.65534)tb07v06(i,j)=tb07v06(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb07v06(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb07v06(pixel=1,scan=1): ',tb07v06(1,1)
C read array: tb for 10h, resolution 10G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res10,10.7GHz,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb10h10,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res10,10.7GHz,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb10h10(i,j)=tb10h10(i,j+ovr)
          if(tb10h10(i,j).lt.65534)tb10h10(i,j)=tb10h10(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb10h10(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb10h10(pixel=1,scan=1): ',tb10h10(1,1)
C read array: tb for 10v, resolution 10G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res10,10.7GHz,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb10v10,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res10,10.7GHz,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb10v10(i,j)=tb10v10(i,j+ovr)
          if(tb10v10(i,j).lt.65534)tb10v10(i,j)=tb10v10(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb10v10(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb10v10(pixel=1,scan=1): ',tb10v10(1,1)
C read array: tb for 18h, resolution 23G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res23,18.7GHz,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb18h23,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res23,18.7GHz,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb18h23(i,j)=tb18h23(i,j+ovr)
          if(tb18h23(i,j).lt.65534)tb18h23(i,j)=tb18h23(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb18h23(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb18h23(pixel=1,scan=1): ',tb18h23(1,1)
C read array: tb for 18v, resolution 23G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res23,18.7GHz,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb18v23,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res23,18.7GHz,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb18v23(i,j)=tb18v23(i,j+ovr)
          if(tb18v23(i,j).lt.65534)tb18v23(i,j)=tb18v23(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb18v23(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb18v23(pixel=1,scan=1): ',tb18v23(1,1)
C read array: tb for 23h, resolution 23G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res23,23.8GHz,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb23h23,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res23,23.8GHz,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb23h23(i,j)=tb23h23(i,j+ovr)
          if(tb23h23(i,j).lt.65534)tb23h23(i,j)=tb23h23(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb23h23(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb23h23(pixel=1,scan=1): ',tb23h23(1,1)
C read array: tb for 23v, resolution 23G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res23,23.8GHz,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb23v23,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res23,23.8GHz,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb23v23(i,j)=tb23v23(i,j+ovr)
          if(tb23v23(i,j).lt.65534)tb23v23(i,j)=tb23v23(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb23v23(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb23v23(pixel=1,scan=1): ',tb23v23(1,1)
C read array: tb for 36h, resolution 36G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res36,36.5GHz,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb36h36,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res36,36.5GHz,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb36h36(i,j)=tb36h36(i,j+ovr)
          if(tb36h36(i,j).lt.65534)tb36h36(i,j)=tb36h36(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb36h36(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb36h36(pixel=1,scan=1): ',tb36h36(1,1)
C read array: tb for 36v, resolution 36G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res36,36.5GHz,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb36v36,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res36,36.5GHz,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb36v36(i,j)=tb36v36(i,j+ovr)
          if(tb36v36(i,j).lt.65534)tb36v36(i,j)=tb36v36(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb36v36(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb36v36(pixel=1,scan=1): ',tb36v36(1,1)
C read array: tb for 89h, resolution 36G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res36,89.0GHz,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb89h36,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res36,89.0GHz,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb89h36(i,j)=tb89h36(i,j+ovr)
          if(tb89h36(i,j).lt.65534)tb89h36(i,j)=tb89h36(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb89h36(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb89h36(pixel=1,scan=1): ',tb89h36(1,1)
C read array: tb for 89v, resolution 36G
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (res36,89.0GHz,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb89v36,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (res36,89.0GHz,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          tb89v36(i,j)=tb89v36(i,j+ovr)
          if(tb89v36(i,j).lt.65534)tb89v36(i,j)=tb89v36(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb89v36(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb89v36(pixel=1,scan=1): ',tb89v36(1,1)
C read array: tb for 89ah
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (original,89GHz-A,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb89ah,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (original,89GHz-A,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          tb89ah(i,j)=tb89ah(i,j+ovr)
          if(tb89ah(i,j).lt.65534)tb89ah(i,j)=tb89ah(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb89ah(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb89ah(pixel=1,scan=1): ',tb89ah(1,1)
C read array: tb for 89av
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (original,89GHz-A,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb89av,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (original,89GHz-A,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          tb89av(i,j)=tb89av(i,j+ovr)
          if(tb89av(i,j).lt.65534)tb89av(i,j)=tb89av(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb89av(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb89av(pixel=1,scan=1): ',tb89av(1,1)
C read array: tb for 89bh
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (original,89GHz-B,H)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb89bh,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (original,89GHz-B,H)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          tb89bh(i,j)=tb89bh(i,j+ovr)
          if(tb89bh(i,j).lt.65534)tb89bh(i,j)=tb89bh(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb89bh(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb89bh(pixel=1,scan=1): ',tb89bh(1,1)
C read array: tb for 89bv
      ! read
      call H5Dopen_f(fhnd
     +,'Brightness Temperature (original,89GHz-B,V)',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,tb89bv,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Brightness Temperature (original,89GHz-B,V)'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & convert to unsignd & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          tb89bv(i,j)=tb89bv(i,j+ovr)
          if(tb89bv(i,j).lt.65534)tb89bv(i,j)=tb89bv(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        tb89bv(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'tb89bv(pixel=1,scan=1): ',tb89bv(1,1)
C read array: pixel data quality for low
      ! read
      call H5Dopen_f(fhnd
     +,'Pixel Data Quality 6 to 36',dhnd,ret)
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_INTEGER,i4d2hi,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Pixel Data Quality 6 to 36'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & separate
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
         pdq06v(i,j)=0
         if(btest(i4d2hi((i-1)*2+1,j+ovr),0))pdq06v(i,j)=1
         if(btest(i4d2hi((i-1)*2+1,j+ovr),1))pdq06v(i,j)=10
         if(btest(i4d2hi((i-1)*2+1,j+ovr),0)
     +     .and.btest(i4d2hi((i-1)*2+1,j+ovr),1))pdq06v(i,j)=11
         pdq06h(i,j)=0
         if(btest(i4d2hi((i-1)*2+1,j+ovr),2))pdq06h(i,j)=1
         if(btest(i4d2hi((i-1)*2+1,j+ovr),3))pdq06h(i,j)=10
         if(btest(i4d2hi((i-1)*2+1,j+ovr),2)
     +     .and.btest(i4d2hi((i-1)*2+1,j+ovr),3))pdq06h(i,j)=11
         pdq07v(i,j)=0
         if(btest(i4d2hi((i-1)*2+1,j+ovr),4))pdq07v(i,j)=1
         if(btest(i4d2hi((i-1)*2+1,j+ovr),5))pdq07v(i,j)=10
         if(btest(i4d2hi((i-1)*2+1,j+ovr),4)
     +     .and.btest(i4d2hi((i-1)*2+1,j+ovr),5))pdq07v(i,j)=11
         pdq07h(i,j)=0
         if(btest(i4d2hi((i-1)*2+1,j+ovr),6))pdq07h(i,j)=1
         if(btest(i4d2hi((i-1)*2+1,j+ovr),7))pdq07h(i,j)=10
         if(btest(i4d2hi((i-1)*2+1,j+ovr),6)
     +     .and.btest(i4d2hi((i-1)*2+1,j+ovr),7))pdq07h(i,j)=11
        enddo
      enddo
      do j=num+1,LMT
        pdq06h(:,j)=0
        pdq06v(:,j)=0
        pdq07h(:,j)=0
        pdq07v(:,j)=0
      enddo
      ! sample display
      write(*,'(a,i3)')'pdq06h(pixel=1,scan=1): ',pdq06h(1,1)
      write(*,'(a,i3)')'pdq06v(pixel=1,scan=1): ',pdq06v(1,1)
      write(*,'(a,i3)')'pdq07h(pixel=1,scan=1): ',pdq07h(1,1)
      write(*,'(a,i3)')'pdq07v(pixel=1,scan=1): ',pdq07v(1,1)
C read array: pixel data quality for high
      ! read
      call H5Dopen_f(fhnd
     +,'Pixel Data Quality 89',dhnd,ret)
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_INTEGER,i4d2hi,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Pixel Data Quality 89'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & separate
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          pdq89ah(i,j)=0; if(btest(i4d2hi(i,j+ovr),0))pdq89ah(i,j)=1
          pdq89av(i,j)=0; if(btest(i4d2hi(i,j+ovr),1))pdq89av(i,j)=1
          pdq89bh(i,j)=0; if(btest(i4d2hi(i,j+ovr),2))pdq89bh(i,j)=1
          pdq89bv(i,j)=0; if(btest(i4d2hi(i,j+ovr),3))pdq89bv(i,j)=1
        enddo
      enddo
      do j=num+1,LMT
        pdq89ah(:,j)=0
        pdq89av(:,j)=0
        pdq89bh(:,j)=0
        pdq89bv(:,j)=0
      enddo
      ! sample display
      write(*,'(a,i3)')'pdq89ah(pixel=1,scan=1): ',pdq89ah(1,1)
      write(*,'(a,i3)')'pdq89av(pixel=1,scan=1): ',pdq89av(1,1)
      write(*,'(a,i3)')'pdq89bh(pixel=1,scan=1): ',pdq89bh(1,1)
      write(*,'(a,i3)')'pdq89bv(pixel=1,scan=1): ',pdq89bv(1,1)
C read array: land ocean flag for low
      ! read
      call H5Dopen_f(fhnd
     +,'Land_Ocean Flag 6 to 36',dhnd,ret)
      sz1(1)=LMT*6
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_INTEGER,loflo,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Land_Ocean Flag 6 to 36'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! separate
      do j=1,num+ovr*2
        do i=1,AM2_DEF_SNUM_LO
          lof06(i,j)=loflo(i,(num+ovr*2)*0+j)
          lof10(i,j)=loflo(i,(num+ovr*2)*1+j)
          lof23(i,j)=loflo(i,(num+ovr*2)*2+j)
          lof36(i,j)=loflo(i,(num+ovr*2)*3+j)
        enddo
      enddo
      ! cutoff overlap
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          lof06(i,j)=lof06(i,j+ovr)
          lof10(i,j)=lof10(i,j+ovr)
          lof23(i,j)=lof23(i,j+ovr)
          lof36(i,j)=lof36(i,j+ovr)
        enddo
      enddo
      do j=num+1,LMT
        lof06(:,j)=0
        lof10(:,j)=0
        lof23(:,j)=0
        lof36(:,j)=0
      enddo
      ! sample display
      write(*,'(a,i3)')'lof06(pixel=1,scan=1): ',lof06(1,1)
      write(*,'(a,i3)')'lof10(pixel=1,scan=1): ',lof10(1,1)
      write(*,'(a,i3)')'lof23(pixel=1,scan=1): ',lof23(1,1)
      write(*,'(a,i3)')'lof36(pixel=1,scan=1): ',lof36(1,1)
C read array: land ocean flag for high
      ! read
      call H5Dopen_f(fhnd
     +,'Land_Ocean Flag 89',dhnd,ret)
      sz1(1)=LMT*2
      sz1(2)=AM2_DEF_SNUM_HI
      call H5Dread_f(dhnd
     +,H5T_NATIVE_INTEGER,lofhi,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Land_Ocean Flag 89'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! separate
      do j=1,num+ovr*2
        do i=1,AM2_DEF_SNUM_HI
          lof89a(i,j)=lofhi(i,(num+ovr*2)*0+j)
          lof89b(i,j)=lofhi(i,(num+ovr*2)*1+j)
        enddo
      enddo
      ! cutoff overlap
      do j=1,num
        do i=1,AM2_DEF_SNUM_HI
          lof89a(i,j)=lof89a(i,j+ovr)
          lof89b(i,j)=lof89b(i,j+ovr)
        enddo
      enddo
      do j=num+1,LMT
        lof89a(:,j)=0
        lof89b(:,j)=0
      enddo
      ! sample display
      write(*,'(a,i3)')'lof89a(pixel=1,scan=1): ',lof89a(1,1)
      write(*,'(a,i3)')'lof89b(pixel=1,scan=1): ',lof89b(1,1)
C read array: earth incidence
      ! read
      call H5Dopen_f(fhnd
     +,'Earth Incidence',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,ear_in,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Earth Incidence'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          ear_in(i,j)=ear_in(i,j+ovr)
          if(ear_in(i,j).gt.-32767)ear_in(i,j)=ear_in(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        ear_in(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'ear_in(pixel=1,scan=1): ',ear_in(1,1)
C read array: earth azimuth
      ! read
      call H5Dopen_f(fhnd
     +,'Earth Azimuth',dhnd,ret)
      call H5Aopen_f(dhnd,'SCALE FACTOR',ahnd,ret)     ! get scale
      call H5Aread_f(ahnd,H5T_NATIVE_REAL,sca,sz1,ret) ! get scale
      call H5Aclose_f(ahnd,ret)                        ! get scale
      sz1(1)=LMT
      sz1(2)=AM2_DEF_SNUM_LO
      call H5Dread_f(dhnd
     +,H5T_NATIVE_REAL,ear_az,sz1,ret,H5S_ALL_F,H5S_ALL_F)
      if(ret.lt.0)then
        write(*,'(a,a)')'H5Dread error: '
     +  ,'Earth Azimuth'
        call exit(1)
      endif
      call H5Dclose_f(dhnd,ret)
      ! cutoff overlap & change scale
      do j=1,num
        do i=1,AM2_DEF_SNUM_LO
          ear_az(i,j)=ear_az(i,j+ovr)
          if(ear_az(i,j).gt.-32767)ear_az(i,j)=ear_az(i,j)*sca
        enddo
      enddo
      do j=num+1,LMT
        ear_az(:,j)=0
      enddo
      ! sample display
      write(*,'(a,f9.2)')'ear_az(pixel=1,scan=1): ',ear_az(1,1)
C close
      call H5Fclose_f(fhnd,ret)
      call H5close_f(ret)
      end
